local frame = CreateFrame("Frame", nil, UIParent)
frame:SetAllPoints(QueueStatusMinimapButton)
frame:SetFrameStrata(HIGH)

--frame:RegisterEvent("LFG_PROPOSAL_SHOW")
--frame:RegisterEvent("LFG_PROPOSAL_FAILED")

	-- Change text here --
local font = frame:CreateFontString("LFR", "OVERLAY", "GameFontNormal") -- The number representing LFR Tank

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font:SetPoint("TOP", QueueStatusMinimapButton, "TOP", -10, -4) 

-- change color here: any combination numbers between 0 and 1
font:SetTextColor(1, 1, 1) 

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE") 

local font2 = frame:CreateFontString("LFR", "OVERLAY", "GameFontNormal") -- The number representing LFR Heal

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font2:SetPoint("TOP", QueueStatusMinimapButton, "TOP", 10, -4) 

-- change color here: any combination numbers between 0 and 1
font2:SetTextColor(1, 1, 1) 

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font2:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local font3 = frame:CreateFontString("LFR", "OVERLAY", "GameFontNormal") -- The number representing LFR DPS

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font3:SetPoint("TOP", QueueStatusMinimapButton, "TOP", 0, 0) 

-- change color here: any combination numbers between 0 and 1
font3:SetTextColor(1, 1, 1) 

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font3:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local font4 = frame:CreateFontString("Heal", "OVERLAY", "GameFontNormal") -- The number representing LFR wait time

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font4:SetPoint("TOP", QueueStatusMinimapButton, "TOP", 0, -8)

-- change color here: any combination numbers between 0 and 1
font4:SetTextColor(1, 1, 1)

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font4:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")


local font5 = frame:CreateFontString("DPS", "OVERLAY", "GameFontNormal") -- The number representing LFD Tank

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font5:SetPoint("BOTTOM", QueueStatusMinimapButton, "BOTTOM", -10, 6)

-- change color here: any combination numbers between 0 and 1
font5:SetTextColor( 1, 1, 1)

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font5:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local font6 = frame:CreateFontString("DPS", "OVERLAY", "GameFontNormal") -- The number representing LFD Heal

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font6:SetPoint("BOTTOM", QueueStatusMinimapButton, "BOTTOM", 10, 6)

-- change color here: any combination numbers between 0 and 1
font6:SetTextColor( 1, 1, 1)

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font6:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local font7 = frame:CreateFontString("DPS", "OVERLAY", "GameFontNormal") -- The number representing LFD DPS

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font7:SetPoint("BOTTOM", QueueStatusMinimapButton, "BOTTOM", 0, 0)

-- change color here: any combination numbers between 0 and 1
font7:SetTextColor( 1, 1, 1)

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font7:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local font8 = frame:CreateFontString("Wait", "OVERLAY", "GameFontNormal") -- The number representing wait time

-- position here: "LEFT", "RIGHT", "TOP", "BOTTOM" in relation to the LFG eye
font8:SetPoint("BOTTOM", QueueStatusMinimapButton, "BOTTOM", 0, 8)

-- change color here: any combination numbers between 0 and 1
font8:SetTextColor( 1, 1, 1)

-- change font style here: font path, text size, and modifiers such as "OUTLINE", MONOCHROME", "THICKOUTLINE" or leave blank for none
font8:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")

local function GetRaidRoles()
local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, totalTanks, totalHealers, totalDPS, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, dpsWait, myWait, queuedTime = GetLFGQueueStats(LE_LFG_CATEGORY_RF)
font:SetText("")
font2:SetText("")
font3:SetText("")
font4:SetText("")
	if hasData then
		if tankNeeds ~= 0 then
			font:SetText(string.format("|cff0000ff%s|r", tankNeeds))
		end
		if healerNeeds ~= 0 then
			font2:SetText(string.format("|cff00ff00%s|r", healerNeeds))
		end
		if dpsNeeds ~= 0 then
			font3:SetText(string.format("|cffff0000%s|r", dpsNeeds))
		end
		if myWait >= 1 then
			font4:SetText(string.format("%s", floor((myWait/60) - ((GetTime() - queuedTime) /60))))
		end
	end

end

local function GetDungeonRoles()
local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, totalTanks, totalHealers, totalDPS, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, dpsWait, myWait, queuedTime = GetLFGQueueStats(LE_LFG_CATEGORY_LFD)
font5:SetText("")
font6:SetText("")
font7:SetText("")
font8:SetText("")
	if hasData then
		if tankNeeds ~= 0 then
			font5:SetText(string.format("|cff0000ff%s|r", tankNeeds))
		end
		if healerNeeds ~= 0 then
			font6:SetText(string.format("|cff00ff00%s|r", healerNeeds))
		end
		if dpsNeeds ~= 0 then
			font7:SetText(string.format("|cffff0000%s|r", dpsNeeds))
		end
		if myWait >= 1 then
			font8:SetText(string.format("%s", floor((myWait/60)- ((GetTime() - queuedTime) /60))))
		end
	end

end

local function update()
GetRaidRoles()
GetDungeonRoles()
end

--local function eventHandler(self, event, ...)
	--if event == "LFG_PROPOSAL_SHOW" then
	
	--elseif event == "LFG_PROPOSAL_FAILED" then
		
	--end
--end
frame:SetScript("OnEvent", eventHandler)

hooksecurefunc("QueueStatusEntry_SetUpLFG", update)
QueueStatusMinimapButton:HookScript("OnShow", update)
if QueueStatusMinimapButton:IsShown() then
	update()
end